



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[LeetCode] Median of Two Sorted Arrays 两个有序数组的中位数</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[LeetCode] Median of Two Sorted Arrays 两个有序数组的中位数</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 18:48:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>There are two sorted arrays&nbsp;nums1&nbsp;and&nbsp;nums2&nbsp;of size m and n respectively.</p>
<p>Find the median of the two sorted arrays. The overall run time complexity should be O(log (m+n)).</p>
<p>You may assume&nbsp;nums1&nbsp;and&nbsp;nums2&nbsp;cannot be both empty.</p>
<p>Example 1:</p>
<pre class="prettyprint linenums">nums1 = [1, 3]<br />
nums2 = [2]

The median is 2.0
</pre>
<p>Example 2:</p>
<pre class="prettyprint linenums">nums1 = [1, 2]<br />
nums2 = [3, 4]

The median is (2 + 3)/2 = 2.5</pre>
<p>这道题让我们求两个有序数组的中位数，而且限制了时间复杂度为 O(log (m+n))，看到这个时间复杂度，自然而然的想到了应该使用二分查找法来求解。但是这道题被定义为 Hard 也是有其原因的，难就难在要在两个未合并的有序数组之间使用二分法，如果这道题只有一个有序数组，让求中位数的话，估计就是个 Easy 题。对于这道题来说，可以将两个有序数组混合起来成为一个有序数组再做吗，图样图森破，这个时间复杂度限制的就是告诉你金坷垃别想啦。还是要用二分法，而且是在两个数组之间使用，感觉很高端啊。回顾一下中位数的定义，如果某个有序数组长度是奇数，那么其中位数就是最中间那个，如果是偶数，那么就是最中间两个数字的平均值。这里对于两个有序数组也是一样的，假设两个有序数组的长度分别为m和n，由于两个数组长度之和 m+n 的奇偶不确定，因此需要分情况来讨论，对于奇数的情况，直接找到最中间的数即可，偶数的话需要求最中间两个数的平均值。为了简化代码，不分情况讨论，使用一个小 trick，分别找第 (m+n+1) / 2 个，和 (m+n+2) / 2 个，然后求其平均值即可，这对奇偶数均适用。若 m+n 为奇数的话，那么其实 (m+n+1) / 2 和 (m+n+2) / 2 的值相等，相当于两个相同的数字相加再除以2，还是其本身。</p>
<p>好，这里需要定义一个函数来在两个有序数组中找到第K个元素，下面重点来看如何实现找到第K个元素。首先，为了避免拷贝产生新的数组从而增加时间复杂度，使用两个变量i和j分别来标记数组 nums1 和 nums2 的起始位置。然后来处理一些 corner cases，比如当某一个数组的起始位置大于等于其数组长度时，说明其所有数字均已经被淘汰了，相当于一个空数组了，那么实际上就变成了在另一个数组中找数字，直接就可以找出来了。还有就是如果 K=1 的话，只要比较 nums1 和 nums2 的起始位置i和j上的数字就可以了。难点就在于一般的情况怎么处理？因为需要在两个有序数组中找到第K个元素，为了加快搜索的速度，可以使用二分法，那么对谁二分呢，数组么？其实要对K二分，意思是需要分别在 nums1 和 nums2 中查找第 K/2 个元素，注意这里由于两个数组的长度不定，所以有可能某个数组没有第 K/2 个数字，所以需要先 check 一下，数组中到底存不存在第 K/2 个数字，如果存在就取出来，否则就赋值上一个整型最大值（目的是要在 nums1 或者 nums2 中先淘汰 K/2 个较小的数字，判断的依据就是看 midVal1 和 midVal2 谁更小，但如果某个数组的个数都不到 K/2 个，自然无法淘汰，所以将其对应的 midVal 值设为整型最大值，以保证其不会被淘汰），若某个数组没有第 K/2 个数字，则淘汰另一个数组的前 K/2 个数字即可。举个例子来说吧，比如 nums1 = {3}，nums2 = {2, 4, 5, 6, 7}，K=4，要找两个数组混合中第4个数字，则分别在 nums1 和 nums2 中找第2个数字，而 nums1 中只有一个数字，不存在第二个数字，则 nums2 中的前2个数字可以直接跳过，为啥呢，因为要求的是整个混合数组的第4个数字，不管 nums1 中的那个数字是大是小，第4个数字绝不会出现在 nums2 的前两个数字中，所以可以直接跳过。</p>
<p>有没有可能两个数组都不存在第 K/2 个数字呢，这道题里是不可能的，因为K不是任意给的，而是给的 m+n 的中间值，所以必定至少会有一个数组是存在第 K/2 个数字的。最后就是二分法的核心啦，比较这两个数组的第 K/2 小的数字 midVal1 和 midVal2 的大小，如果第一个数组的第 K/2 个数字小的话，那么说明要找的数字肯定不在 nums1 中的前 K/2 个数字，可以将其淘汰，将 nums1 的起始位置向后移动 K/2 个，并且此时的K也自减去 K/2，调用递归，举个例子来说吧，比如 nums1 = {1, 3}，nums2 = {2, 4, 5}，K=4，要找两个数组混合中第4个数字，那么分别在 nums1 和 nums2 中找第2个数字，nums1 中的第2个数字是3，nums2 中的第2个数字是4，由于3小于4，所以混合数组中第4个数字肯定在 nums2 中，可以将 nums1 的起始位置向后移动 K/2 个。反之，淘汰 nums2 中的前 K/2 个数字，并将 nums2 的起始位置向后移动 K/2 个，并且此时的K也自减去 K/2，调用递归即可，参见代码如下：</p>
<p>C++ 解法一：</p>
<div>
<pre class="prettyprint linenums">class Solution {<br />
public:<br />
    double findMedianSortedArrays(vector&lt;int&gt;&amp; nums1, vector&lt;int&gt;&amp; nums2) {<br />
        int m = nums1.size(), n = nums2.size(), left = (m + n + ) / , right = (m + n + ) / ;<br />
        return (findKth(nums1, , nums2, , left) + findKth(nums1, , nums2, , right)) / 2.0;<br />
    }<br />
    int findKth(vector&lt;int&gt;&amp; nums1, int i, vector&lt;int&gt;&amp; nums2, int j, int k) {<br />
        if (i &gt;= nums1.size()) return nums2[j + k - ];<br />
        if (j &gt;= nums2.size()) return nums1[i + k - ];<br />
        if (k == ) return min(nums1[i], nums2[j]);<br />
        int midVal1 = (i + k /  -  &lt; nums1.size()) ? nums1[i + k /  - ] : INT_MAX;<br />
        int midVal2 = (j + k /  -  &lt; nums2.size()) ? nums2[j + k /  - ] : INT_MAX;<br />
        if (midVal1 &lt; midVal2) {<br />
            return findKth(nums1, i + k / , nums2, j, k - k / );<br />
        } else {<br />
            return findKth(nums1, i, nums2, j + k / , k - k / );<br />
        }<br />
    }<br />
};</pre>
</div>
<p>Java 解法一：</p>
<div>
<pre class="prettyprint linenums">public class Solution {<br />
    public double findMedianSortedArrays(int[] nums1, int[] nums2) {<br />
        int m = nums1.length, n = nums2.length, left = (m + n + ) / , right = (m + n + ) / ;<br />
        return (findKth(nums1, , nums2, , left) + findKth(nums1, , nums2, , right)) / 2.0;<br />
    }<br />
    int findKth(int[] nums1, int i, int[] nums2, int j, int k) {<br />
        if (i &gt;= nums1.length) return nums2[j + k - ];<br />
        if (j &gt;= nums2.length) return nums1[i + k - ];<br />
        if (k == ) return Math.min(nums1[i], nums2[j]);<br />
        int midVal1 = (i + k /  -  &lt; nums1.length) ? nums1[i + k /  - ] : Integer.MAX_VALUE;<br />
        int midVal2 = (j + k /  -  &lt; nums2.length) ? nums2[j + k /  - ] : Integer.MAX_VALUE;<br />
        if (midVal1 &lt; midVal2) {<br />
            return findKth(nums1, i + k / , nums2, j, k - k / );<br />
        } else {<br />
            return findKth(nums1, i, nums2, j + k / , k - k / );<br />
        }<br />
    }<br />
}</pre>
</div>
<p>上面的解法一直使用的是原数组，同时用了两个变量来分别标记当前的起始位置。我们也可以直接生成新的数组，这样就不要用起始位置变量了，不过拷贝数组的操作可能会增加时间复杂度，也许会超出限制，不过就算当个思路拓展也是极好的。首先要判断数组是否为空，为空的话，直接在另一个数组找第K个即可。还有一种情况是当 K = 1 时，表示要找第一个元素，只要比较两个数组的第一个元素，返回较小的那个即可。这里分别取出两个数组的第 K/2 个数字的位置坐标i和j，为了避免数组没有第 K/2 个数组的情况，每次都和数组长度做比较，取出较小值。这里跟上面的解法有些许不同，上面解法直接取出的是值，而这里取出的是位置坐标，但是思想都是很类似的。不同在于，上面解法中每次固定淘汰 K/2 个数字，而这里由于取出了合法的i和j，所以每次淘汰i或j个。评论区有网友提出，可以让 j = k-i，这样也是对的，可能还更好一些，收敛速度可能会更快一些，参见代码如下：</p>
<p>C++ 解法二：</p>
<div>
<pre class="prettyprint linenums">class Solution {<br />
public:<br />
    double findMedianSortedArrays(vector&lt;int&gt;&amp; nums1, vector&lt;int&gt;&amp; nums2) {<br />
        int m = nums1.size(), n = nums2.size();<br />
        return (findKth(nums1, nums2, (m + n + ) / ) + findKth(nums1, nums2, (m + n + ) / )) / 2.0;<br />
    }<br />
    int findKth(vector&lt;int&gt; nums1, vector&lt;int&gt; nums2, int k) {<br />
        if (nums1.empty()) return nums2[k - ];<br />
        if (nums2.empty()) return nums1[k - ];<br />
        if (k == ) return min(nums1[], nums2[]);<br />
        int i = min((int)nums1.size(), k / ), j = min((int)nums2.size(), k / );<br />
        if (nums1[i - ] &gt; nums2[j - ]) {<br />
            return findKth(nums1, vector&lt;int&gt;(nums2.begin() + j, nums2.end()), k - j);<br />
        } else {<br />
            return findKth(vector&lt;int&gt;(nums1.begin() + i, nums1.end()), nums2, k - i);<br />
        }<br />
        return ;<br />
    }<br />
};</pre>
</div>
<p>Java 解法二：</p>
<div>
<pre class="prettyprint linenums">public class Solution {<br />
    public double findMedianSortedArrays(int[] nums1, int[] nums2) {<br />
        int m = nums1.length, n = nums2.length, left = (m + n + 1) / 2, right = (m + n + 2) / 2;<br />
        return (findKth(nums1, nums2, left) + findKth(nums1, nums2, right)) / 2.0;<br />
    }<br />
    int findKth(int[] nums1, int[] nums2, int k) {<br />
        int m = nums1.length, n = nums2.length;<br />
        if (m == 0) return nums2[k - 1];<br />
        if (n == 0) return nums1[k - 1];<br />
        if (k == 1) return Math.min(nums1[0], nums2[0]);<br />
        int i = Math.min(m, k / 2), j = Math.min(n, k / 2);<br />
        if (nums1[i - 1] &gt; nums2[j - 1]) {<br />
            return findKth(nums1, Arrays.copyOfRange(nums2, j, n), k - j);<br />
        } else {<br />
            return findKth(Arrays.copyOfRange(nums1, i, m), nums2, k - i);<br />
        }<br />
    }<br />
}</pre>
</div>
<p>此题还能用迭代形式的二分搜索法来解，是一种相当巧妙的应用，这里就参照 <a href="https://leetcode.com/problems/median-of-two-sorted-arrays/discuss/2471/very-concise-ologminmn-iterative-solution-with-detailed-explanation" rel="external nofollow noreferrer">stellari 大神的帖子</a>&nbsp;来讲解吧。所谓的中位数，换一种角度去看，其实就是把一个有序数组分为长度相等的两段，中位数就是前半段的最大值和后半段的最小值的平均数，也就是离分割点相邻的两个数字的平均值。比如说对于偶数个数组 [1 3 5 7]，那么分割开来就是 [1 3 / 5 7]，其中 '/' 表示分割点，中位数就是3和5的平均值。对于奇数个数组 [1 3 4 5 7]，可以分割为 [1 3 4 / 4 5 7]，可以发现左右两边都有个4，则中位数是两个4的平均数，还是4。这里使用L表示分割点左边的数字，R表示分割点右边的数字，则对于 [1 3 5 7] 来说，L=3，R=5。对于 [1 3 4 5 7] 来说，L=4，R=4。那么对于长度为N的数组来说，可以分别得到L和R的位置，如下所示：</p>
<div>
<pre class="prettyprint linenums">N        Index of L        Index of R
</pre>
</div>
<p>观察上表，可以得到规律，Idx(L)= (N-1)/2，idx(R) = N/2，所以中位数可以用下式表示：</p>
<div>
<pre class="prettyprint linenums">(L + R) /  = (A[(N - ) / ] + A[N / ]) / </pre>
</div>
<p>为了统一数组长度为奇数和偶数的情况，可以使用一个小 tricky，即在每个数字的两边都加上一个特殊字符，比如井号，这个 tricky 其实在马拉车算法中也使用过，可以参见博主之前的帖子&nbsp;<a href="http://www.cnblogs.com/grandyang/p/4475985.html" rel="external nofollow noreferrer">Manacher's Algorithm 马拉车算法</a>。这样做的好处是不管奇数或者偶数，加井号后数组的长度都是奇数，并且切割点的位置也是确定的，比如：</p>
<div>
<pre class="prettyprint linenums">[   ]    -&gt;    [#  #  #  #  #]        N =<br />
index                                newN = 

[    ]    -&gt;    [#  #  #  #  #  #]        N =<br />
index                                   newN = </pre>
</div>
<p>这里的N是原数组的长度，newN 是添加井号后新数组的长度，可以发现 newN = 2N+1，而且切割点永远都在新数组中坐标为N的位置，且 idx(L) = (N-1)/2，idx(R) = N/2，这里的N就可以换成分割点的位置，岂不美哉（注意这里的 idx(L) 和 idx(R) 表示的是在未填充#号的坐标位置）！现在假设有两个数组：</p>
<div>
<pre class="prettyprint linenums">[    ]    -&gt;    [#  #  #  #  #  #]        N1 =<br />
index                                   newN1 = 

[   ]    -&gt;    [#  #  #  #  #]        N2 =<br />
index                                newN2 = </pre>
</div>
<p>跟只有一个数组的情况类似，这里需要找到一个切割点，使得其分别可以将两个数组分成左右两部分，需要满足的是两个左半边中的任意一个数字都要小于两个右半边数组的数字，注意这里可能有的左半边或右半边会为空，但是两个左半边数字的个数和应该等于两个右半边的个数和。这里还可以观察出一些规律：</p>
<p>1. 总共有 2N1 + 2N2 + 2 个位置，那么除去两个分割点，两个左右半边应该各有 N1 + N2 个数字。</p>
<p>2. 因此，对于一个在 A2 数组中的分割点位置 C2 = K，在 A1 数组中的位置应该为 C1 = N1 + N2 - K，比如假如在 A2 中的分割点位置为 C2 = 2，那么在 A1 中的位置为 C1 = 4 + 5 - C2 = 7。</p>
<div>
<pre class="prettyprint linenums">[#  #  #  # (/) #  #]

[#  /  #  #  #]</pre>
</div>
<p>3. 假如两个数组都被分割了，那么就应该会有两个L和R，分别是：</p>
<div>
<pre class="prettyprint linenums">L1 = A1[(C1 - ) / ]<br />
R1 = A1[C1 / ]

L2 = A2[(C2 - ) / ]<br />
R2 = A2[C2 / ]</pre>
</div>
<p>对于上面的例子就有：</p>
<div>
<pre class="prettyprint linenums">L1 = A1[( - ) / ] = A1[] =<br />
R1 = A1[ / ] = A1[] = 

L2 = A2[( - ) / ] = A2[] =<br />
R2 = A2[ / ] = A2[] = </pre>
</div>
<p>现在需要检测这个切割点是否是正确的中位数的切割点，那么根据之前的分析，任意的左半边的数字都需要小于等于右半边的数字，L1 和 L2 是左半边的最大的数字，R1 和 R2 是右半边的最小的数字，所以需要满足下列关系：</p>
<div>
<pre class="prettyprint linenums">L1 &lt;= R1 &amp;&amp; L1 &lt;= R2 &amp;&amp; L2 &lt;= R1 &amp;&amp; L2 &lt;= R2</pre>
</div>
<p>由于两个数组都是有序的，所以 L1 &lt;= R1 和 L2 &lt;= R2 都是满足的，那么就只需要满足下列的不等式即可：</p>
<div>
<pre class="prettyprint linenums">L1 &lt;= R2 &amp;&amp; L2 &lt;= R1</pre>
</div>
<p>这样的话就可以利用二分搜索了，假如 L1 &gt; R2 的话，说明数组 A1 的左半边的数字过大了，需要把切割点 C1 往左移动。假如 L2 &gt; R1，说明数组 A2 的左半边数字过大，需要把分割点 C2 左移。若满足上面的条件，说明当前切割点就是正确的，那么中位数就可以求出来了，即为：</p>
<div>
<pre class="prettyprint linenums">(max(L1, L2) + min(R1, R2)) / </pre>
</div>
<p>最后还有两点注意事项：</p>
<p>1. 由于 C1 和 C2 是可以互相计算而得，即一个确定了，另一个就可以计算出来了。所以尽量去移动较短的那个数组，这样得到的时间复杂度为 O(lg(min(N1, N2)))。</p>
<p>2. 对于 corner case 的处理，当切割点在 0 或者 2n 的位置时，将L或R的值分别赋值为整型最小值和最大值，这不会改变正确的切割点的位置，会使得代码实现更加方便。</p>
<p>C++ 解法三：</p>
<div>
<pre class="prettyprint linenums">class Solution {<br />
public:<br />
    double findMedianSortedArrays(vector&lt;int&gt;&amp; nums1, vector&lt;int&gt;&amp; nums2) {<br />
        int m = nums1.size(), n = nums2.size();<br />
        if (m &lt; n) return findMedianSortedArrays(nums2, nums1);<br />
        if (n == ) return ((double)nums1[(m - ) / ] + (double)nums1[m / ]) / 2.0;<br />
        int left = , right = n * ;<br />
        while (left &lt;= right) {<br />
            int mid2 = (left + right) / ;<br />
            int mid1 = m + n - mid2;<br />
            double L1 = mid1 ==  ? INT_MIN : nums1[(mid1 - ) / ];<br />
            double L2 = mid2 ==  ? INT_MIN : nums2[(mid2 - ) / ];<br />
            double R1 = mid1 == m *  ? INT_MAX : nums1[mid1 / ];<br />
            double R2 = mid2 == n *  ? INT_MAX : nums2[mid2 / ];<br />
            if (L1 &gt; R2) left = mid2 + ;<br />
            else if (L2 &gt; R1) right = mid2 - ;<br />
            else return (max(L1, L2) + min(R1, R2)) / ;<br />
        }<br />
        return -;<br />
    }<br />
};</pre>
</div>
<p>Java 解法三：</p>
<div>
<pre class="prettyprint linenums">public class Solution {<br />
    public double findMedianSortedArrays(int[] nums1, int[] nums2) {<br />
        int m = nums1.length, n = nums2.length;<br />
        if (m &lt; n) return findMedianSortedArrays(nums2, nums1);<br />
        if (n == 0) return (nums1[(m - 1) / 2] + nums1[m / 2]) / 2.0;<br />
        int left = 0, right = 2 * n;<br />
        while (left &lt;= right) {<br />
            int mid2 = (left + right) / 2;<br />
            int mid1 = m + n - mid2;<br />
            double L1 = mid1 == 0 ? Double.MIN_VALUE : nums1[(mid1 - 1) / 2];<br />
            double L2 = mid2 == 0 ? Double.MIN_VALUE : nums2[(mid2 - 1) / 2];<br />
            double R1 = mid1 == m * 2 ? Double.MAX_VALUE : nums1[mid1 / 2];<br />
            double R2 = mid2 == n * 2 ? Double.MAX_VALUE : nums2[mid2 / 2];<br />
            if (L1 &gt; R2) left = mid2 + 1;<br />
            else if (L2 &gt; R1) right = mid2 - 1;<br />
            else return (Math.max(L1, L2) + Math.min(R1, R2)) / 2;<br />
        }<br />
        return -1;<br />
    }<br />
}</pre>
</div>
<p>Github 同步地址：</p>
<p><a href="https://github.com/grandyang/leetcode/issues/4" rel="external nofollow noreferrer">https://github.com/grandyang/leetcode/issues/4</a></p>
<p>参考资料：</p>
<p><a href="https://leetcode.com/problems/median-of-two-sorted-arrays/" rel="external nofollow noreferrer">https://leetcode.com/problems/median-of-two-sorted-arrays/</a></p>
<p><a href="https://leetcode.com/problems/median-of-two-sorted-arrays/discuss/2496/Concise-JAVA-solution-based-on-Binary-Search" rel="external nofollow noreferrer">https://leetcode.com/problems/median-of-two-sorted-arrays/discuss/2496/Concise-JAVA-solution-based-on-Binary-Search</a></p>
<p><a href="https://leetcode.com/problems/median-of-two-sorted-arrays/discuss/2499/Share-my-simple-O(log(m%2Bn))-solution-for-your-reference" rel="external nofollow noreferrer">https://leetcode.com/problems/median-of-two-sorted-arrays/discuss/2499/Share-my-simple-O(log(m%2Bn))-solution-for-your-reference</a></p>
<p><a href="https://leetcode.com/problems/median-of-two-sorted-arrays/discuss/2471/Very-concise-O(log(min(MN)))-iterative-solution-with-detailed-explanation" rel="external nofollow noreferrer">https://leetcode.com/problems/median-of-two-sorted-arrays/discuss/2471/Very-concise-O(log(min(MN)))-iterative-solution-with-detailed-explanation</a></p>
<p><a href="http://www.cnblogs.com/grandyang/p/4606334.html" rel="external nofollow noreferrer">LeetCode All in One 题目讲解汇总(持续更新中...)</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8o4y2pq.html">《java JDK7 学习笔记》之接口与多态</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z32kvq.html">【软件工程】&OpenCurlyDoubleQuote;谁是卧底&rdquo;之NABC分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/495k2o09.html">&lbrack;转&rsqb;Windows多进程编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4l6358.html">讲解Canvas中的一些重要方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv63m18.html">Java问题：Quartz，Hibernate，Spring，Tomcat中定时任务无故停止，没有错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okdnkp9.html">Java 7 中 NIO&period;2 的使用&mdash;&mdash;文件递归操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1d1338.html">【BZOJ】【1012】【JSOI2008】最大数maxnumber</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm3yl09.html">Linux系统时间与RTC时间【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y7g50q.html">ASP&period;NET MVC 之 路由配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydmo5mq.html">Java核心技术，让计算机&amp;quot&semi;一芯多用&amp;quot&semi;的多线程技术</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpp0x39.html">An Overview of Complex Event Processing2</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjem3y8.html">【BZOJ4010】【HNOI2015】菜肴制作（拓扑排序）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zvx2e9.html">20165230 《Java程序设计》第1周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y5x1r8.html">Top Page</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j47n0q.html">PHP人工智能库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv40lj8.html">Unity AssetBundle打包资源工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25npvwq.html">大坑啊oracle的隐式转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jrjlnq.html">二叉堆复习（包括d堆）</a>
		</li>
						<li><a href="https://www.batexi.com/a/902555oq.html">adb connect 192&period;168&period;1&period;10 failed to connect to 192&period;168&period;1&period;10&colon;5555</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm53mw9.html">Java多线程 -sleep 用法详解</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/rqlrw0qo.html">Http协议相关内容</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql4p09o.html">基于STM32Cube的脉冲输出</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pl7kqx.html">ToolsCodeTemplate使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8om3xqz.html">MongoDB 存储引擎和数据模型设计</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m1zr8k.html">&period;NET4&period;5新特性之异步编程（Async和Await）的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m3rp9k.html">分享一个php邮件库&mdash;&mdash;swiftmailer</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m36r9k.html">严重&colon; Exception sending context initialized event to listener instance of class</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8oxge8z.html">jdk顺序表笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qydwedq.html">使用PowerShell修改操作系统&OpenCurlyDoubleQuote;环境变量&rdquo;</a>
			</li>
						<li><a href="https://www.batexi.com/a/495xxd68.html">Linux Standards Base LSB</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
